=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2007-11-29 18:41:01 +0000
+++ bzrlib/builtins.py	2007-11-30 21:10:18 +0000
@@ -4000,17 +4000,17 @@
     def _run(self, submit_branch, revision, public_branch, remember, format,
              no_bundle, no_patch, output, from_, mail_to, message):
         from bzrlib.revision import NULL_REVISION
+        branch = Branch.open_containing(from_)[0]
         if output is None:
             outfile = StringIO()
         elif output == '-':
             outfile = self.outf
         else:
             outfile = open(output, 'wb')
+        # we may need to write data into branch's repository to calculate
+        # the data to send.
+        branch.lock_write()
         try:
-            branch = Branch.open_containing(from_)[0]
-            # we may need to write data into branch's repository to calculate
-            # the data to send.
-            branch.lock_write()
             if output is None:
                 config = branch.get_config()
                 if mail_to is None:

=== modified file 'bzrlib/tests/blackbox/test_send.py'
--- bzrlib/tests/blackbox/test_send.py	2007-11-28 17:27:10 +0000
+++ bzrlib/tests/blackbox/test_send.py	2007-11-30 21:10:18 +0000
@@ -17,6 +17,7 @@
 
 
 import os
+import sys
 from StringIO import StringIO
 
 from bzrlib import (
@@ -236,3 +237,12 @@
                                  'grandparent'])
         self.assertEqual('revision1', md.base_revision_id)
         self.assertEqual('revision3', md.revision_id)
+
+    def test_nonexistant_branch(self):
+        if sys.platform == "win32":
+            location = "C:/i/do/not/exist/"
+        else:
+            location = "/i/do/not/exist/"
+        out, err = self.run_bzr(["send", "--from", location], retcode=3)
+        self.assertEqual(out, '')
+        self.assertEqual(err, 'bzr: ERROR: Not a branch: "%s".\n' % location)

